bookings/urls.py
from django.urls import path, re_path
from django.views.generic import TemplateView

from bookings.views.bookings import (
    BookingDetailView,
    BookingUpdateView,
    BookingDeleteView,
    BookingCreateView,
)
from bookings.views.occurrences import (
    BookingOccurrenceCreateView,
    BookingOccurrenceUpdateView,
    BookingOccurrenceDeleteView,
)
from bookings.views.other import (
    ResourceCategoryDayView,
    CountableOccurrencesList,
    BookingFormView,
)
from bookings.views.api_va import api_va

app_name = "bookings"

urlpatterns = [
    path(
        "home/", TemplateView.as_view(template_name="bookings/home.html"), name="home"
    ),
    re_path(
        r"^resource-category/(?P<id>[0-9]+)$",
        ResourceCategoryDayView.as_view(),
        name="resource-category-day",
    ),
    re_path(r"^form/(?P<pk>[0-9]+)$", BookingFormView.as_view(), name="booking-form"),
    re_path(
        r"^booking/(?P<pk>[0-9]+)$", BookingDetailView.as_view(), name="booking-details"
    ),
    re_path(
        r"^booking/(?P<pk>[0-9]+)/edit$",
        BookingUpdateView.as_view(),
        name="booking-update",
    ),
    re_path(
        r"^booking/(?P<pk>[0-9]+)/delete$",
        BookingDeleteView.as_view(),
        name="booking-delete",
    ),
    path("booking/new", BookingCreateView.as_view(), name="booking-new"),
    re_path(
        r"^booking/(?P<booking_pk>[0-9]+)/occurrence/new$",
        BookingOccurrenceCreateView.as_view(),
        name="occurrence-new",
    ),
    re_path(
        r"^booking/(?P<booking_pk>[0-9]+)/occurrence/(?P<pk>[0-9]+)$",
        BookingOccurrenceUpdateView.as_view(),
        name="occurrence-edit",
    ),
    re_path(
        r"^booking/(?P<booking_pk>[0-9]+)/occurrence/(?P<pk>[0-9]+)/delete$",
        BookingOccurrenceDeleteView.as_view(),
        name="occurrence-delete",
    ),
    path("occurrences", CountableOccurrencesList.as_view(), name="occurrences_filter"),
    re_path(r"^api/va/(?P<va_key>c[0-9]+)$", api_va, name="api_va"),
    path("help", TemplateView.as_view(template_name="bookings/help.html"), name="help"),
]

resa/urls.py
from django.urls import path, include
from django.contrib import admin

urlpatterns = [
    path("admin/", admin.site.urls),
    path("", include("account.urls")),
    path("book/", include("bookings.urls", namespace="bookings")),
]

bookings/views/api_va.py
from django.contrib.auth.decorators import login_required
from django.http import JsonResponse

from bookings.adhesion import AdhesionAPI


@login_required
def api_va(request, va_key):
    api = AdhesionAPI()
    va_info = api.get_va(va_key)
    if va_info is None:
        return JsonResponse(dict(), status=404)
    va_info = {
        key: va_info[key] for key in ["first_name", "last_name", "email", "phone"]
    }
    return JsonResponse(va_info)

bookings/views/bookings.py
import datetime as dt
import logging

import dateutil.parser
from django.contrib import messages
from django.contrib.auth.decorators import login_required, permission_required
from django.core.paginator import Paginator, EmptyPage
from django.shortcuts import get_object_or_404, redirect
from django.urls import reverse, reverse_lazy
from django.utils.decorators import method_decorator
from django.utils.translation import gettext_lazy as _
from django.views.generic import CreateView, DeleteView, DetailView, UpdateView
from django.views.generic.base import ContextMixin

from bookings.forms import BookingFormForm
from bookings.models import ResourceCategory, Resource, Booking, BookingOccurrence

log = logging.getLogger(__name__)


class BaseBookingView(ContextMixin):
    booking = None

    def get_context_data(self, **kwargs):
        context = super(BaseBookingView, self).get_context_data(**kwargs)
        page = self.request.GET.get("occ_page", 1)

        occurrences = self.booking.get_occurrences().order_by("start")
        paginator = Paginator(occurrences, 10)

        try:
            occurrences = paginator.page(page)
        except EmptyPage:
            occurrences = paginator.page(paginator.num_pages)

        context["occurrences"] = occurrences
        return context


class BookingCreateView(CreateView):
    model = Booking
    fields = [
        "contact_first_name",
        "contact_last_name",
        "contact_email",
        "contact_phone",
        "contact_asso",
        "reason",
        "details",
    ]
    template_name = "bookings/booking/booking_new.html"
    decorators = [login_required, permission_required("bookings.add_booking")]
    start = None
    end = None
    booking = None
    object = None
    resource = None

    def get_form(self, form_class=None):
        form = super(BookingCreateView, self).get_form(form_class=form_class)
        booking_type = self.resource.category.booking_type
        if booking_type == ResourceCategory.ASSO:
            form.fields["contact_asso"].required = True
        elif booking_type == ResourceCategory.STUDENT:
            del form.fields["contact_asso"]
        return form

    def get_success_url(self):
        return (
            reverse("bookings:occurrence-new", kwargs={"booking_pk": self.booking.pk})
            + "?start="
            + str(self.start.isoformat())
            + "&end="
            + str(self.end.isoformat())
            + "&resource="
            + str(self.resource.id)
        )

    def dispatch(self, request, *args, **kwargs):
        self.resource = get_object_or_404(Resource, pk=self.request.GET.get("resource"))

        start = self.request.GET.get("start")
        end = self.request.GET.get("end")

        if start is not None:
            self.start = dateutil.parser.parse(start)
        else:
            self.start = dt.datetime.now()

        if end is not None:
            self.end = dateutil.parser.parse(end)
        else:
            self.end = self.start

        return super(BookingCreateView, self).dispatch(request, *args, **kwargs)

    def get_context_data(self, **kwargs):
        context = super(BookingCreateView, self).get_context_data(**kwargs)
        context["start"] = self.start
        context["end"] = self.end
        context["resource_id"] = self.resource.id

        return context

    @method_decorator(decorators)
    def post(self, request, *args, **kwargs):
        form = self.get_form()

        if form.is_valid():
            self.booking = form.save()

            messages.success(request, _("Réservation créée avec succès"))
            return self.form_valid(form)
        else:
            return self.form_invalid(form)

    @method_decorator(decorators)
    def get(self, request, *args, **kwargs):
        return super(BookingCreateView, self).get(request, *args, **kwargs)


class BookingDetailView(DetailView, BaseBookingView):
    model = Booking
    template_name = "bookings/booking/booking_detail.html"
    booking = None

    def dispatch(self, request, *args, **kwargs):
        self.booking = get_object_or_404(Booking, pk=self.kwargs["pk"])
        return super(BookingDetailView, self).dispatch(request, *args, **kwargs)

    def get_context_data(self, **kwargs):
        context = super(BookingDetailView, self).get_context_data(**kwargs)
        resource_requires_form = Resource.objects.filter(category__booking_form=True)

        form_needed = (
            BookingOccurrence.objects.filter(booking=self.booking)
            .filter(resources__in=resource_requires_form)
            .distinct()
            .exists()
        )

        if form_needed:
            context["booking_form"] = BookingFormForm(booking=self.booking)

        return context

    @method_decorator(login_required)
    def get(self, request, *args, **kwargs):
        return super(BookingDetailView, self).get(request, *args, **kwargs)

    @method_decorator(login_required)
    def post(self, request, *args, **kwargs):
        return redirect(to="bookings:booking-form", pk=request.POST.get("occurrence"))


class BookingUpdateView(UpdateView, BaseBookingView):
    model = Booking
    template_name = "bookings/booking/booking_edit.html"
    fields = [
        "contact_first_name",
        "contact_last_name",
        "contact_email",
        "contact_phone",
        "contact_asso",
        "reason",
        "details",
    ]
    decorators = [login_required, permission_required("bookings.change_booking")]
    booking = None

    def dispatch(self, request, *args, **kwargs):
        self.booking = get_object_or_404(Booking, pk=self.kwargs["pk"])
        return super(BookingUpdateView, self).dispatch(request, *args, **kwargs)

    @method_decorator(decorators)
    def get(self, request, *args, **kwargs):
        return super(BookingUpdateView, self).get(request, *args, **kwargs)

    @method_decorator(decorators)
    def post(self, request, *args, **kwargs):
        return super(BookingUpdateView, self).post(request, *args, **kwargs)


class BookingDeleteView(DeleteView, BaseBookingView):
    model = Booking
    decorators = [login_required, permission_required("bookings.delete_booking")]
    booking = None
    template_name = "bookings/booking/booking_delete.html"

    def dispatch(self, request, *args, **kwargs):
        self.booking = self.get_object()
        return super(BookingDeleteView, self).dispatch(request, *args, **kwargs)

    def get_context_data(self, **kwargs):
        context = super(BookingDeleteView, self).get_context_data(**kwargs)
        context["booking"] = self.booking

        return context

    def get_success_url(self):
        return reverse_lazy("bookings:home")

    @method_decorator(decorators)
    def get(self, request, *args, **kwargs):
        return super(BookingDeleteView, self).get(request, *args, **kwargs)

    @method_decorator(decorators)
    def delete(self, request, *args, **kwargs):
        return super(BookingDeleteView, self).delete(request, *args, **kwargs)

bookings/templates/bookings/booking/booking_delete.html
{% extends 'bookings/booking/booking_detail.html' %}
{% load i18n %}
{% load crispy_forms_filters %}

{% block title %}
    {% translate 'supprimer la réservation' as title %}
    {{ title|capfirst }}
{% endblock title %}

{% block information %}
    <div class="card-header">
        <a href="{% url 'bookings:booking-details' pk=booking.pk %}"
           class="btn btn-sm btn-warning pull-end">
            <span class="fa-solid fa-xmark"></span> {% translate 'Annuler' %}
        </a>
        <h3 class="card-title">
            <span class="fa-solid fa-rectangle-list"></span> {% translate 'Informations' %}
        </h3>
    </div>
    <div class="card-body">
        <form action="{% url 'bookings:booking-delete' pk=booking.pk %}" method="post">
            {% csrf_token %}
            <p>{% translate "Êtes-vous certain de vouloir supprimer la réservation suivante ? Toutes les occurrences liées seront supprimées." %}</p>
            <p>{{ booking }}</p>
            <button type="submit" class="btn btn-danger btn-block">
                <span class="fa-solid fa-trash-can"></span> Supprimer
            </button>
        </form>
    </div>
{% endblock information %}

bookings/templates/bookings/booking/booking_detail.html
{% extends 'base.html' %}
{% load i18n %}
{% load crispy_forms_tags %}
{% load crispy_forms_filters %}

{% block add-content %}
    <h2>
        {% block title %}
            {% translate 'réservation' as title %}
            {{ title|title }}
        {% endblock title %}
    </h2>
    {% block error %}
    {% endblock %}
    <div class="row">
        <div class="col-md-6">
            <div class="card card-light">
                {% block information %}
                    <div class="card-header">
                        <a href="{% url 'bookings:booking-update' pk=booking.pk %}"
                           class="btn btn-sm btn-primary pull-end">
                            <span class="fa-solid fa-pen-to-square"></span>
                        </a>
                        <h3 class="card-title">
                            <span class="fa-solid fa-rectangle-list"></span> {% translate 'Informations' %}
                        </h3>
                    </div>
                    <div class="list-group">
                        <div class="list-group-item">
                            <span class="fa-solid fa-user"></span> {{ booking.contact_full_name }}
                        </div>
                        <div class="list-group-item">
                            <span class="fa-solid fa-envelope"></span> {{ booking.contact_email }}
                        </div>
                        <div class="list-group-item">
                            <span class="fa-solid fa-phone"></span> {{ booking.contact_phone }}
                        </div>
                        {% if booking.contact_asso %}
                            <div class="list-group-item">
                                <span class="fa-solid fa-briefcase"></span> {{ booking.contact_asso }}
                            </div>
                        {% endif %}
                        <div class="list-group-item">
                            <span class="fa-solid fa-circle-info"></span> {{ booking.reason }}
                        </div>
                        {% if booking.details %}
                            <div class="list-group-item">
                                <span class="fa-solid fa-message"></span> {{ booking.details|linebreaks }}
                            </div>
                        {% endif %}
                    </div>
                {% endblock information %}
            </div>
            {% if booking.occurrences.count > 0 and booking_form %}
                <h3>Fiches de location</h3>
                <form method="post" target="_blank">
                    {{ booking_form.media }}
                    {% csrf_token %}
                    {{ booking_form|crispy }}
                    <button type="submit" class="btn btn-primary btn-block">
                        {% translate 'Éditer la fiche de location' %}
                    </button>
                </form>

            {% endif %}
        </div>
        {% block occurrences %}
            <div class="col-md-6">
                {% block start_form %}
                    <form>
                {% endblock start_form %}
                <div class="card card-light">
                    {% block occurrence_form %}
                        <div class="card-header">
                            {% if perms.bookings.add_bookingoccurrence %}
                                <a href="{% url 'bookings:occurrence-new' booking_pk=booking.id %}"
                                   class="btn btn-sm btn-success pull-end">
                                    <span class="fa-solid fa-plus"></span>
                                </a>
                            {% endif %}
                            <h3 class="card-title"><span
                                    class="fa-solid fa-calendar"></span> {% translate 'Occurrences' %}
                            </h3>
                        </div>
                    {% endblock occurrence_form %}

                    <div class="list-group">
                        {% for occ in occurrences %}
                            {% if perms.bookings.change_bookingoccurrence %}
                                <a href="{% url 'bookings:occurrence-edit' booking_pk=booking.pk pk=occ.pk %}"
                                   class="list-group-item{% if occ == current_occurrence %} active{% endif %}">
                            {% else %}
                                <div class="list-group-item">
                            {% endif %}

                        <span class="fa-solid fa-clock"></span>

                        {{ occ.resources_names|join:', ' }} : {{ occ.str_dates|capfirst }}

                        <span class="badge">{{ occ.get_resources_count }}</span>

                        {% if perms.bookings.change_bookingoccurrence %}
                            </a>
                        {% else %}
                            </div>
                        {% endif %}
                        {% endfor %}
                    {% if occurrences.has_other_pages %}
                        <div class="list-group-item">

                            <nav>
                                <ul class="pagination">
                                    <li class="{% if occurrences.has_previous == False %}disabled{% endif %}">
                                        <a href="?occ_page={{ occurrences.number|add:'-1' }}">&laquo;</a>
                                    </li>

                                    {% for page in occurrences.paginator.page_range %}
                                        <li class="{% if page == occurrences.number %}active{% endif %}">
                                            <a href="?occ_page={{ page }}">{{ page }}</a>
                                        </li>
                                    {% endfor %}

                                    <li class="{% if occurrences.has_next == False %}disabled{% endif %}">
                                        <a href="?occ_page={{ occurrences.number|add:'1' }}">&raquo;</a>
                                    </li>
                                </ul>
                            </nav>
                        </div>
                    {% endif %}
                </div>
                {% block end_form %}
                    </form>
                {% endblock end_form %}
            </div>
        {% endblock occurrences %}
    </div>

{% endblock add-content %}

bookings/templates/bookings/booking/booking_edit.html
{% extends 'bookings/booking/booking_detail.html' %}
{% load i18n %}
{% load crispy_forms_filters %}
{% load static %}

{% block title %}
    {% translate 'modifier la réservation' as title %}
    {{ title|capfirst }}
{% endblock title %}

{% block javascript %}
    {{ block.super }}
    <script defer src="{% static 'bookings/booking_edit.js' %}"></script>
{% endblock javascript %}

{% block information %}
    <div class="card-header">
        <a href="{% url 'bookings:booking-details' pk=booking.pk %}"
           class="btn btn-sm btn-warning pull-end">
            <span class="fa-solid fa-xmark"></span> {% translate 'Annuler' %}
        </a>
        <h3 class="card-title">
            <span class="fa-solid fa-rectangle-list"></span> {% translate 'Informations' %}
        </h3>
    </div>
    <div class="card-body">
        <form action="{% url 'bookings:booking-update' pk=booking.pk %}" method="post">
            {{ form.media }}
            {% csrf_token %}
            {{ form|crispy }}
        <div class="btn-group pull-right">
            <button type="submit" class="btn btn-success">
                <span class="fa-solid fa-floppy-disk"></span> Enregistrer
            </button>
            {% if perms.bookings.delete_bookingoccurrence %}
                <a href="{% url 'bookings:booking-delete' pk=booking.pk %}" class="btn btn-danger">
                    <span class="fa-solid fa-trash-can"></span> Supprimer
                </a>
            {% endif %}
        </div>
        </form>
    </div>
{% endblock information %}

bookings/templates/bookings/booking/booking_form.html
{% comment %}

Fichier correspondant au formulaire de réservation à imprimer.

{% endcomment %}
{% load i18n %}
{% load static %}
<!DOCTYPE html>
<html lang="fr">
<head>
    <title>Resa &bull; {% translate 'Fiche de location' %}</title>

    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

    <link rel="icon" type="image/png" href={% static 'logo-bde-square-favicon.png' %}>

    {% block style %}
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/css/bootstrap.min.css"
              integrity="sha384-xOolHFLEh07PJGoPkLv1IbcEPTNtaed2xpHsD9ESMhqIYd0nLMwNLD69Npy4HI+N"
              crossorigin="anonymous">
        <link rel="stylesheet" href="{% static 'default_style.css' %}">
    {% endblock style %}
</head>
<body>
<div class="container">
    <h1>
        <img class="logo-title" src="{% static 'logo-bde-black-form.png' %}" alt="Logo BdE">
        {% translate 'Fiche de location' %}
        <small>{{ category }}</small>
    </h1>

    {% if booking.contact_asso %}
        <div class="row">
            <div class="col-lg-12">
                <div class="card bg-light">
                    <div class="card-header">
                        <h3 class="card-title text-center">
                            <span class="fa-solid fa-briefcase"></span> {{ booking.contact_asso }}
                        </h3>
                    </div>
                </div>
            </div>
        </div>
    {% endif %}

    <a href="javascript:if(window.print)window.print()" class="btn btn-lg btn-primary d-print-none">Imprimer</a>
    <div class="row">
        <div class="col-md-4">
            <div class="card card-light">
                <div class="card-header">
                    <h3 class="card-title">
                        <span class="fa-solid fa-rectangle-list"></span> {% translate 'Contact' %}
                    </h3>
                </div>
                <div class="list-group">
                    <div class="list-group-item">
                        <span class="fa-solid fa-user"></span> {{ booking.contact_full_name }}
                    </div>
                    <div class="list-group-item">
                        <span class="fa-solid fa-envelope"></span> {{ booking.contact_email }}
                    </div>
                    <div class="list-group-item">
                        <span class="fa-solid fa-phone"></span> {{ booking.contact_phone }}
                    </div>
                    <div class="list-group-item">
                        <span class="fa-solid fa-circle-info"></span> {{ booking.reason }}
                    </div>
                    {% if booking.details %}
                        <div class="list-group-item">
                            <span class="fa-solid fa-message"></span> {{ booking.details|linebreaks }}
                        </div>
                    {% endif %}
                </div>
            </div>
        </div>
        <div class="col-md-8">
            <div class="card card-light">
                <div class="card-header">
                    <h3 class="card-title">
                        <span class="fa-solid fa-rectangle-list"></span> {% translate "Dates" %}
                    </h3>
                </div>
                <div class="list-group">
                    <div class="list-group-item">
                        <span class="fa-solid fa-floppy-disk"></span>
                        Réservation {{ occurrence.created_at|date:"SHORT_DATETIME_FORMAT" }}
                    </div>
                    <div class="list-group-item">
                        <span class="fa-solid fa-right-from-bracket"></span>
                        Départ {{ occurrence.start|date:"SHORT_DATETIME_FORMAT" }}
                    </div>
                    <div class="list-group-item">
                        <span class="fa-solid fa-right-to-bracket"></span>
                        Retour {{ occurrence.end|date:"SHORT_DATETIME_FORMAT" }}
                    </div>
                </div>
            </div>
        </div>
    </div>

    {% for paragraph in paragraphs %}
        <div class="no-break">
            <h2>{{ paragraph.order_form }}. {{ paragraph.title }}</h2>
            <p>
                {{ paragraph.content }}
            </p>
        </div>
    {% endfor %}


    <div class="no-break">
        <h2>{% translate 'Ressources empruntées' %}</h2>
        <table class="table table-striped table-bordered table-responsive table-text-center">
            <thead>
                <tr>
                    <th scope="col">{% translate 'Matériel' %}</th>
                    <th scope="col">{% translate 'Lieu' %}</th>
                    <th scope="col">{% translate 'Quantité réservée' %}</th>
                    <th scope="col">{% translate 'Quantité départ' %}</th>
                    <th scope="col">{% translate 'Quantité retour' %}</th>
                    <th scope="col">{% translate 'Frais de location' %}</th>
                    <th scope="col">{% translate 'Caution' %}</th>
                    <th scope="col">{% translate "Carte d'étudiant/d'identité" %}</th>
                </tr>
            </thead>
            <tbody>
            {% for booking in occurrence.bookings.all %}
                <tr>
                    <td>{{ booking.resource.name }}</td>
                    <td>{% if booking.resource.place %}{{ booking.resource.place }}{% endif %}</td>
                    <td>{{ booking.count }}</td>
                    <td></td>
                    <td></td>
                    <td>{% widthratio booking.fee 100 1 %} €</td>
                    <td>{% widthratio booking.guarantee 100 1 %} €</td>
                    <td>{% if booking.resource.id_card_guarantee %}{% translate 'Oui' %}{% else %}
                        {% translate 'Non' %}{% endif %}</td>
                </tr>
            {% endfor %}
            <tr class="total">
                <th scope="col"><strong>{% translate 'Total' %}</strong></th>
                <th></th>
                <th></th>
                <th></th>
                <th></th>
                <th>{% widthratio total.fee 100 1 %} €</th>
                <th>{% widthratio total.guarantee 100 1 %} €</th>
                <th></th>
            </tr>
            </tbody>
        </table>
    </div>

    <div class="no-break">
        <h2>{% translate 'État des lieux sortant' %}</h2>
        <div class="row">
            <div class="col-lg-12">
                <div class="card card-light">
                    <div class="card-header">
                        <h3 class="card-title">Commentaires</h3>
                    </div>
                    <div class="card-body inventory">

                    </div>
                </div>
            </div>
        </div>
        <p>
            <input type="checkbox" title="Caution payée"> Caution payée
        </p>
        <p>
            <input type="checkbox" title="Location versée"> Location versée
        </p>
        <div class="row">
            <div class="col-lg-6">
                <div class="card card-light">
                    <div class="card-header">
                        <h3 class="card-title">Étudiant</h3>
                    </div>
                    <div class="card-body signatures">
                        Signature étudiant :
                    </div>
                </div>
            </div>
            <div class="col-lg-6">
                <div class="card card-light">
                    <div class="card-header">
                        <h3 class="card-title">Permanencier BdE</h3>
                    </div>
                    <div class="card-body signatures-bde">
                        <p>Nom :</p>
                        <p>Signature :</p>
                    </div>
                </div>
            </div>
        </div>
    </div>


    <div class="no-break">
        <h2>{% translate 'État des lieux retour' %}</h2>
        <div class="row">
            <div class="col-lg-12">
                <div class="card card-light">
                    <div class="card-header">
                        <h3 class="card-title">Commentaires</h3>
                    </div>
                    <div class="card-body inventory">

                    </div>
                </div>
            </div>
        </div>

        <div class="row">
            <div class="col-lg-6">
                <div class="card card-light">
                    <div class="card-header">
                        <h3 class="card-title">Étudiant</h3>
                    </div>
                    <div class="card-body signatures">
                        Signature étudiant :
                    </div>
                </div>
            </div>
            <div class="col-lg-6">
                <div class="card card-light">
                    <div class="card-header">
                        <h3 class="card-title">Permanencier BdE</h3>
                    </div>
                    <div class="card-body signatures-bde">
                        <p>Nom :</p>
                        <p>Signature :</p>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
</body>
</html>

bookings/templates/bookings/booking/booking_new.html
{% extends 'bookings/booking/booking_detail.html' %}
{% load i18n %}
{% load crispy_forms_filters %}
{% load static %}

{% block title %}
    {% translate 'Créer une réservation' as title %}
    {{ title|capfirst }}
{% endblock title %}

{% block javascript %}
    {{ block.super }}
    <script defer src="{% static 'bookings/booking_edit.js' %}"></script>
    <script defer src="{% static 'bookings/api_va.js' %}"></script>
{% endblock javascript %}

{% block error %}
    <div class="alert alert-danger fade show" role="alert" id="va-error-block" style="display: none;">
        <span id="va-error-message"></span>
    </div>
{% endblock error %}

{% block information %}
    <div class="card-header">
        <a href="{% url 'bookings:home' %}"
           class="btn btn-sm btn-warning pull-end">
            <span class="fa-solid fa-xmark"></span> {% translate 'Annuler' %}
        </a>
        <h3 class="card-title">
            <span class="fa-solid fa-rectangle-list"></span> {% translate 'Informations' %}
        </h3>
    </div>
    <div class="card-body">
        <form action="javascript:void(0);" id="va_form">
            <div class="form-group">
                <label class="form-label" for="va_card_input">Carte VA</label>
                <div class="input-group">
                    <input type="text" class="form-control" id="va_card_input" autofocus>
                    <span class="input-group-text px-0 py-0">
                        <button class="btn btn-success" id="va_button" type="submit">Remplissage Auto</button>
                    </span>
                </div>
            </div>
        </form>
        <form action="{% url 'bookings:booking-new' %}?start={{ start.isoformat }}&end={{ end.isoformat }}&resource={{ resource_id }}"
              method="post">
            {{ form.media }}
            {% csrf_token %}
            {{ form|crispy }}
            <div class="btn-group pull-end">
                <button type="submit" class="btn btn-success">
                    <span class="fa-solid fa-floppy-disk"></span> Enregistrer
                </button>
            </div>
        </form>
    </div>
{% endblock information %}

{% block occurrences %}
{% endblock occurrences %}